#ifndef BWIDGETS_SIZE_HPP
#define BWIDGETS_SIZE_HPP

#include <basic_widgets/core/type/concepts.hpp>

namespace bwidgets
{
    struct Size
    {
        int w;
        int h;

        [[nodiscard]] inline auto operator-() const noexcept -> Size
        {
            return {-w, -h};
        }
        [[nodiscard]] inline auto operator+(const Size& s) const noexcept -> Size
        {
            return {w + s.w, h + s.h};
        }
        [[nodiscard]] inline auto operator-(const Size& s) const noexcept -> Size
        {
            return {w - s.w, h - s.h};
        }

        template<Numeric N>
        [[nodiscard]] inline auto operator*(N a) const noexcept -> Size
        {
            return {a * w, a * h};
        }
    };
}

#endif
