#ifndef BWIDGETS_ALIGNED_LAYOUT_HPP
#define BWIDGETS_ALIGNED_LAYOUT_HPP

#include <basic_widgets/w/base/layout.hpp>

namespace bwidgets
{
    class AlignedLayout final : public Layout
    {
    private:
        void _update_layout(const SDL_Rect&) override;

    public:
        enum struct Alignment
        {
            HORIZONTAL,
            VERTICAL
        } alignment;

        AlignedLayout(Alignment align) noexcept : alignment(align) {}

        [[nodiscard]] auto size() const noexcept -> Size override;
    };
}

#endif
