#ifndef BWIDGETS_MOUSE_HANDLER_HPP
#define BWIDGETS_MOUSE_HANDLER_HPP

#include <functional>

#include <basic_widgets/w/feat/focus_handler.hpp>

struct SDL_MouseButtonEvent;
struct SDL_MouseMotionEvent;

namespace bwidgets
{
    class MouseHandler : public virtual FocusHandler
    {
    protected:
        const SDL_Rect* _click_area = nullptr;
        bool            _is_hovered = false;
        bool            _is_pushed  = false;

        virtual void _handle_mouse_button(const SDL_MouseButtonEvent&,
                                          const SDL_Rect&) {};
        virtual void _handle_mouse_motion(const SDL_MouseMotionEvent&,
                                          const SDL_Rect&) {};
        virtual void _on_push(bool) {};

    public:
        std::function<void(const SDL_MouseButtonEvent&)> click_handler = nullptr;

        virtual auto handle_mouse(const SDL_MouseButtonEvent&, const SDL_Rect&)
          -> MouseHandler* final;
        virtual auto handle_mouse(const SDL_MouseMotionEvent&, const SDL_Rect&)
          -> MouseHandler* final;
        virtual auto push(bool) -> MouseHandler* final;
    };
}

#endif
